#pragma hdrstop

#include "OAdapter.h"
#include "OUtils.h"

#pragma package(smart_init)

using namespace OAdapter;
using namespace OUtils;

////////////////////////////////////////////////////////////////////////////////
//
// OAdapter::CAdapter::...
//
PResTable CAdapter::Execute(const AnsiString Name, PTable Values) const
{
    try
    {
        const_iterator res = find(Name);
        if (end() == res)
        {
            ErrorMessage("   \"" + Name + "\"  ");
            return OAdapter::PResTable(new OAdapter::CResTable(false));
        }
        PResTable r = res->second(Values);
        return r;
    } catch (const Exception &E)
    {
        CatchExceptionMessage("  Execute  OAdapter::CAdapter", E);
        return PResTable(NULL);
    } catch (...)
    {
        CatchEllipsisMessage("   Execute  OAdapter::CAdapter");
        return PResTable(NULL);
    }
}

////////////////////////////////////////////////////////////////////////////////
//
// OAdapter::CMFAAdapter::...
//
TForm* CMFAAdapter::MainForm()
{
    try
    {
        PResTable r = Execute("Main.MainForm", PTable(NULL));
        if (!r->Valid) return NULL;
        return reinterpret_cast<TForm*>(static_cast<unsigned int>((*r)[0]["MainForm"]));
    } catch (const Exception &E)
    {
        CatchExceptionMessage("  MainForm  OAdapter::CMFAAdapter", E);
        return NULL;
    } catch (...)
    {
        CatchEllipsisMessage("   MainForm  OAdapter::CMFAAdapter");
        return NULL;
    }
}

////////////////////////////////////////////////////////////////////////////////

